<template>
  <b-container fluid>
    <b-card :header="caption">
      <div slot="header">
        Статьи
        <div class="card-header-actions">
          <button :disabled="isDisabled()" class="btn btn-primary btn-sm" @click="openAddingModal">
            <i class="icon-plus"></i>
          </button>
        </div>
      </div>
      <nav>
        <b-form-input v-model="filter" placeholder="Поиск..." />
      </nav>
      <b-table :hover="hover" :striped="striped" :bordered="bordered" :small="small" @filtered="onFiltered" :filter="filter" responsive :items="items" :fields="fields" :current-page="currentPage" :per-page="perPage">
        <template slot="action" slot-scope="data">
          <b-button  size="sm" @click.stop="info(data.item)" class="mr-1 tableActionbtn" :disabled="isDisabled()">
            <i class="icon-pencil"></i>
          </b-button>
        </template>
      </b-table>
      <nav>
        <b-pagination :total-rows="items.length" :per-page="perPage" v-model="currentPage" prev-text="Предыдущая" next-text="Следующая" hide-goto-end-buttons/>
      </nav>
    </b-card>

    <b-modal id="modalInfo" @hide="resetModal" title="Редактирование статьи" centered @ok="edit" ok-only>
      <b-container fluid>
        <b-form-group>
          <label>Статья</label>
          <b-form-input type="text" name="modalInfo.name" placeholder="название" v-model="modalInfo.name"></b-form-input>
        </b-form-group>
        <b-btn class="mt-3" variant="primary" block @click="edit">Изменить</b-btn>
        <!-- <b-btn class="mt-3" variant="outline-danger" block @click="deleting(modalInfo._id)">Удалить</b-btn> -->
      </b-container>
      <div slot="modal-footer" class="w-100">
      </div>
    </b-modal>
    <b-modal id="addingModal" @hide="resetModal" title="Добавление статьи" centered @ok="adding" ok-only>
      <b-container fluid>
        <b-form-group>
          <label>Статья</label>
          <b-form-input type="text" name="addedModal.name" placeholder="название" v-model="addedModal.name"></b-form-input>
        </b-form-group>
        <b-btn class="mt-3" variant="primary" :disabled="disabled" block @click="adding">Добавить</b-btn>
      </b-container>
      <div slot="modal-footer" class="w-100">
      </div>
    </b-modal>
  </b-container>
</template>

<script>
import Api from '@/services/Api'

export default {
  name: 'Articles',
  components: {

  },
  props: {
    caption: {
      type: String,
      default: 'Статьи'
    },
    hover: {
      type: Boolean,
      default: true
    },
    striped: {
      type: Boolean,
      default: true
    },
    bordered: {
      type: Boolean,
      default: true
    },
    small: {
      type: Boolean,
      default: true
    }
  },
  data: () => {
    return {
      userLevel: localStorage.getItem('level'),
      items: [],
      fields: [
        { key: 'name', sortable: true, label: 'Имя' },
        { key: 'action', label: 'Действия' }
      ],
      currentPage: 1,
      perPage: 10,
      totalRows: 0,
      rowCount: 1,
      filter: null,
      modalInfo: {
        _id: '',
        name: ''
      },
      addedModal: {
        name: ''
      },
    }
  },
  computed: {
    disabled () {
      if (this.addedModal.name.length > 0) {
        return false
      } else {
        return true
      }
    },

  },
  methods: {
    isDisabled() {
      return this.userLevel === "2"
    },
    getArticles () {
      Api().get('getcauses').then(response => {
        this.items = response.data.causes
      })
    },
    adding (e) {
      Api().post('addCause', this.addedModal).then(response => {
        this.resetModal()
        window.location.reload()
      })
    },
    edit (e) {
      Api().post('editcause', this.modalInfo).then(response => {
        this.resetModal()
        window.location.reload()
      })
    },
    deleting (_id) {
      const answer = confirm('Нажмите OK для продолжения или Cancel для выхода.')
      if (answer) {
        Api().post('deletecause', {_id}).then(response => {
          if (response.data.n && response.data.n > 0) {
            this.resetModal()
            window.location.reload()
          } else {
            alert('ne udalilsya')
          }
        })
      } else {
        this.resetModal()
      }
    },
    info (_item) {
      this.modalInfo = _item
      this.$root.$emit('bv::show::modal', 'modalInfo')
    },
    resetModal () {
      this.addedModal.name = ''
    },
    onFiltered (filteredItems) {
      this.rowCount = filteredItems.length
      this.currentPage = 1
    },
    openAddingModal () {
      this.$root.$emit('bv::show::modal', 'addingModal')
    }
  },
  beforeMount () {
    this.getArticles()
  }
}
</script>
